#include "funlib.h"
#define PI 3.14159265358979



//-------------------uint16数组取最大-------------------------------------
uint16_T  ArrMax(uint16_T *Data, uint16_T n)
{
    uint16_T i;
	uint16_T DataMax;
    DataMax = Data[0];
    for(i = 0; i < n; i++)
    {
        if (DataMax < Data[i])
        {
            DataMax = Data[i];
        }
    }
	return DataMax;
}

//-----------------uint16数组取最小-------------------------------------
uint16_T  ArrMin(uint16_T *Data, uint16_T n)
{
    uint16_T i;
	uint16_T DataMin;
    DataMin = Data[0];
    for(i = 0; i < n; i++)
    {
        if (DataMin > Data[i])
        {
            DataMin = Data[i];
        }
    }
	return DataMin;
}
//

/////////////////////////// int16数组求均值////////////////////////////////////
int16_T ArrMean(int16_T *Data, uint16_T n)
{
    uint16_T i;
    int32_T Sum = 0;
    int16_T DataMean;
    
    for (i = 0;i < n ;i++)
    {
        Sum = Sum + Data[i];
    }
    DataMean = (int16_T)Sum /n;
    return DataMean;
}

//-----------------real_T 限幅函数
real_T Saturation_r(real_T in,real_T LowLim,real_T UpLim)
{
   real_T out;

   out = in > LowLim ? in : LowLim;
   out = out > UpLim ? UpLim : out;
   return out;
}

//-----------------uint16 限幅函数

uint16_T Saturation_u(uint16_T in,uint16_T LowLim,uint16_T UpLim)
{
   uint16_T out;

   out = in > LowLim ? in : LowLim;
   out = out > UpLim ? UpLim : out;
   return out;
}


// ---------------------滤波控制变动速率-------------------------------------- 
uint16_T DataFilt(uint16_T in, uint16_T *out, uint16_T Lim)
{
    int16_T delt;
    delt = (int16_T)(in - *out);
    if (delt > Lim)
    {
        *out = *out + (delt > Lim ? Lim : delt);
    }
    if (delt < -Lim)
    {
        *out = *out + (delt < -Lim  ? -Lim  : delt);
    }
    if (delt <= Lim && delt >= -Lim)
    {
        *out = in;
    }
    return *out;
}

// ---------------------滤波控制变动速率-------------------------------------- 
uint8_T DataFilt8(uint8_T in, uint8_T *out, uint8_T Lim)
{
    int8_T delt;
    delt = (int8_T)(in - *out);
    if (delt > Lim)
    {
        *out = *out + (delt > Lim ? Lim : delt);
    }
    if (delt < -Lim)
    {
        *out = *out + (delt < -Lim  ? -Lim  : delt);
    }
    if (delt <= Lim && delt >= -Lim)
    {
        *out = in;
    }
    return *out;
}

//-------------------uint16 to uint16的一维查表--------------------------------------  
uint16_T look1_u16tu16(uint16_T u0, const uint16_T *bp0, const uint16_T *table, uint16_T MaxLen)
{
    

	uint32_T bpIdx = 0;
	uint32_T iLeft = 0;
	uint32_T iRght = 0;
	uint16_T y = 0;
	uint32_T yL_0d0 = 0;
	uint32_T yR_0d0 = 0;
	uint32_T maxIndex = MaxLen - 1;
	if (u0 <= bp0[0U])
	{
		iLeft = 0U;
		iRght = 0U;
	}
	else if (u0 < bp0[maxIndex])
	{
		//۷Ѱu0λ
		bpIdx = maxIndex >> 1U;
		iLeft = 0U;
		iRght = maxIndex;
		while ((iRght - iLeft) > 1)
		{
			if (u0 < bp0[bpIdx])
			{
				iRght = bpIdx;
			}
			else
			{
				iLeft = bpIdx;
			}
			bpIdx = (iRght + iLeft) >> 1U;
		}
	}
	else
	{
		iLeft = maxIndex;
		iRght = maxIndex;
	}
	//ҵλԺֵ
	if (iLeft!=iRght)
	{
		//Բֵ
		yR_0d0 = table[iLeft + 1U];
		yL_0d0 = table[iLeft];
		if (yR_0d0 >= yL_0d0)
		{
			y = (uint16_T)(((uint32_T)(u0 - bp0[iLeft]) * (yR_0d0 - yL_0d0)) / (bp0[iLeft + 1] - bp0[iLeft]) + yL_0d0);
		}
		else
		{
			y = (uint16_T)((yL_0d0 - ((uint32_T)(u0 - bp0[iLeft]) * (yL_0d0 - yR_0d0)) / (bp0[iLeft + 1] - bp0[iLeft])));
		}
	}
	else
	{
		y = (uint16_T)table[iLeft];
	}
	return y;
}


//-------------------int16 to uint16的一维查表--------------------------------------  
uint16_T look1_i16tu16(int16_T u0, const int16_T *bp0, const uint16_T *table, uint16_T MaxLen)
{
	uint32_T bpIdx = 0;
	uint32_T iLeft = 0;
	uint32_T iRght = 0;
	uint16_T y = 0;
	uint32_T yL_0d0 = 0;
	uint32_T yR_0d0 = 0;
	uint32_T maxIndex = MaxLen - 1;
	if (u0 <= bp0[0U])
	{
		iLeft = 0U;
		iRght = 0U;
	}
	else if (u0 < bp0[maxIndex])
	{
		//۷Ѱu0λ
		bpIdx = maxIndex >> 1U;
		iLeft = 0U;
		iRght = maxIndex;
		while ((iRght - iLeft) > 1)
		{
			if (u0 < bp0[bpIdx])
			{
				iRght = bpIdx;
			}
			else
			{
				iLeft = bpIdx;
			}
			bpIdx = (iRght + iLeft) >> 1U;
		}
	}
	else
	{
		iLeft = maxIndex;
		iRght = maxIndex;
	}
	//ҵλԺֵ
	if (iLeft!=iRght)
	{
		//Բֵ
		yR_0d0 = table[iLeft + 1U];
		yL_0d0 = table[iLeft];
		if (yR_0d0 >= yL_0d0)
		{
			y = (uint16_T)(((uint32_T)(u0 - bp0[iLeft]) * (yR_0d0 - yL_0d0)) / (bp0[iLeft + 1] - bp0[iLeft]) + yL_0d0);
		}
		else
		{
			y = (uint16_T)((yL_0d0 - ((uint32_T)(u0 - bp0[iLeft]) * (yL_0d0 - yR_0d0)) / (bp0[iLeft + 1] - bp0[iLeft])));
		}
	}
	else
	{
		y = (uint16_T)table[iLeft];
	}
	return y;
}


//  uint16 二维查表
uint16_T look2_u16u16tu16(uint16_T x, uint16_T y, const uint16_T xTable[], const uint16_T yTable[], const uint16_T zTable[], uint16_T xLen, uint16_T yLen)
{
  uint16_T xMaxIndex;
  uint16_T yMaxIndex;
  uint16_T xIndexLeft;
  uint16_T xIndexRight;
  uint16_T yIndexLeft;
  uint16_T yIndexRight;
  uint16_T xValueLeft;
  uint16_T xValueRight;
  uint16_T yValueLeft;
  uint16_T yValueRight;
  uint16_T bpIdx;
  uint32_T zIndex1;
  uint32_T zIndex2;
  uint32_T zValueMid_xLeft;
  uint32_T zValueMid_xRight;
  uint16_T z;
  xMaxIndex = xLen - 1;
  yMaxIndex = yLen - 1;
  
  if (x <= xTable[0U])
  {
    xIndexLeft = 0U;
    xIndexRight = 0U;
  }
  else if (x >= xTable[xMaxIndex])
  {
    xIndexLeft = xMaxIndex;
    xIndexRight = xMaxIndex;
  }
  else
  {
    bpIdx = xMaxIndex >> 1U;
    xIndexLeft = 0;
    xIndexRight = xMaxIndex;
    while (xIndexRight - xIndexLeft > 1U)
    {
      if (x < xTable[bpIdx])
      {
        xIndexRight = bpIdx;
      }
      else
      {
        xIndexLeft = bpIdx;
      }

      bpIdx = (xIndexRight + xIndexLeft) >> 1U;
    }
  }
  xValueLeft = xTable[xIndexLeft];
  xValueRight = xTable[xIndexRight];


  if (y <= yTable[0U])
  {
    yIndexLeft = 0U;
    yIndexRight = 0U;
  }
  else if (y >= yTable[yMaxIndex])
  {
    yIndexLeft = yMaxIndex;
    yIndexRight = yMaxIndex;
  }
  else
  {
    bpIdx = yMaxIndex >> 1U;
    yIndexLeft = 0;
    yIndexRight = yMaxIndex;
    while (yIndexRight - yIndexLeft > 1U)
    {
      if (y < yTable[bpIdx])
      {
        yIndexRight = bpIdx;
      }
      else
      {
        yIndexLeft = bpIdx;
      }

      bpIdx = (yIndexRight + yIndexLeft) >> 1U;
    }
  }
  yValueLeft = yTable[yIndexLeft];
  yValueRight = yTable[yIndexRight];


  zIndex1 = yIndexLeft * xLen + xIndexLeft;
  zIndex2 = yIndexRight * xLen + xIndexLeft;
  if (yIndexLeft != yIndexRight)
  {
    if (zTable[zIndex2] > zTable[zIndex1])
    {
      zValueMid_xLeft = (uint16_T)(((uint32_T)(y - yValueLeft) * (zTable[zIndex2] - zTable[zIndex1])) / (yValueRight - yValueLeft) + zTable[zIndex1]);
    }
    else
    {
      zValueMid_xLeft = (uint16_T)(zTable[zIndex1] - ((uint32_T)(y - yValueLeft) * (zTable[zIndex1] - zTable[zIndex2])) / (yValueRight - yValueLeft));
    }

    if (zTable[zIndex2 + 1] > zTable[zIndex1 + 1])
    {
      zValueMid_xRight = (uint16_T)(((uint32_T)(y - yValueLeft) * (zTable[zIndex2 + 1] - zTable[zIndex1 + 1])) / (yValueRight - yValueLeft) + zTable[zIndex1 + 1]);
    }
    else
    {
      zValueMid_xRight = (uint16_T)(zTable[zIndex1 + 1] - ((uint32_T)(y - yValueLeft) * (zTable[zIndex1 + 1] - zTable[zIndex2 + 1])) / (yValueRight - yValueLeft));
    }
  }
  else
  {
    zValueMid_xLeft = (uint16_T)zTable[zIndex1];
    zValueMid_xRight = (uint16_T)zTable[zIndex1 + 1];
  }
  if (xIndexLeft != xIndexRight)
  {
    if (zValueMid_xLeft < zValueMid_xRight)
    {
      z = (uint16_T)(((uint32_T)(x - xValueLeft) * (zValueMid_xRight - zValueMid_xLeft)) / ((uint16_T)(xValueRight - xValueLeft)) + zValueMid_xLeft);
    }
    else
    {
      z = (uint16_T)(zValueMid_xLeft - ((uint32_T)(x - xValueLeft) * (zValueMid_xLeft - zValueMid_xRight)) / ((uint16_T)(xValueRight - xValueLeft)));
    }
  }
  else
  {
    z = (uint16_T)(zValueMid_xLeft);
  }
  return z;
}


//-----------------------------------------------诊断大于阈值     
boolean_T DiagThrSystem1(boolean_T Enable, boolean_T precondition, uint16_T Input, uint16_T fltThr, uint16_T recThr, uint8_T fltNumThr, uint8_T recNumThr, uint8_T *fltNum, uint8_T *recNum, boolean_T *fitFlg)
{

    if (Enable && precondition && Input > fltThr)
    {
        *fltNum = (*fltNum + 1) > 200 ? 200 : (*fltNum + 1);
    }
    else
    {
        *fltNum = 0;
    }

    if (Enable && precondition && Input < recThr)
    {
        *recNum = (*recNum + 1) > 200 ? 200 : (*recNum + 1);
    }
    else
    {
        *recNum = 0;
    }

    if ((*fltNum > fltNumThr || (*fitFlg && *recNum < recNumThr)) && precondition)
    {
        *fitFlg = true;
    }
    else
    {
        *fitFlg = false;
    }
    return *fitFlg;
}

//================================诊断小于阈值===================================
boolean_T DiagThrSystem2(boolean_T Enable, boolean_T precondition, uint16_T Input, uint16_T fltThr, uint16_T recThr, uint8_T fltNumThr, uint8_T recNumThr, uint8_T *fltNum, uint8_T *recNum, boolean_T *fitFlg)
{
    if (Enable && precondition && Input < fltThr)
    {
        *fltNum = (*fltNum + 1) > 200 ? 200 : (*fltNum + 1);
    }
    else
    {
        *fltNum = 0;
    }

    if (Enable && precondition && Input > recThr)
    {
        *recNum = (*recNum + 1) > 200 ? 200 : (*recNum + 1);
    }
    else
    {
        *recNum = 0;
    }

    if ((*fltNum > fltNumThr || (*fitFlg && *recNum < recNumThr)) && precondition)
    {
        *fitFlg = true;
    }
    else
    {
        *fitFlg = false;
    }

    return *fitFlg;
}

//---------------------------判断条件成立次数
boolean_T JudgeTimeSystem(boolean_T Enable, boolean_T Input, uint16_T *N, uint16_T Thr)
{
    boolean_T Flg = false;
    if (Input && Enable)
    {
        *N = (*N + 1) > 20000 ? 20000 : (*N + 1);
    }
    else
    {
        *N = 0;
    }
    if (*N > Thr && Enable)
    {
        Flg = true;
    }
    else
    {
        Flg = false;
    }
    return Flg;
}



//
void fft(creal_T *X,uint16_T N)
{
    uint16_T i = 0;
    uint16_T j = 0;
    uint16_T k = 0;
    uint16_T l = 0;
    creal_T up;
    creal_T down;
    creal_T product;
    creal_T W[N];
    RaderReverse(X,N);
    for(i = 0;i < N;i++)
    {
        W[i].re = cos(2*PI/N*i);
		W[i].im = -sin(2*PI/N*i);
    }
    for(i = 0;i < log(N)/log(2);i++)
    {
        l = 1<<i;
        for(j=0;j < N;j += 2*l)
        {
            for(k = 0;k < l;k++)
            {
                cmul(X[j+k+l],W[N*k/2/l],&product);
                cadd(X[j+k],product,&up); 
                csub(X[j+k],product,&down);
                X[j+k] = up;
                X[j+k+l] =down;
            }
        }
    }
}
//
void RaderReverse(creal_T *X, uint16_T N)
{
    uint16_T i;
    uint16_T j;
    uint16_T k;
    creal_T temp;
    j = N/2;
    for(i = 1; i < N - 1; i++)
    {
        if(i < j)
        {
            temp = X[j];
            X[j] = X[i];
            X[i] = temp;
        }
        k = N/2;
        while(k <= j)
        {
            j = j - k;
            k = k/2;
        }
        j = j + k;
    }
}
//
void cmul(creal_T a,creal_T b,creal_T *c)
{
   c->re = a.re * b.re - a.im * b.im;
   c->im = a.re * b.im + a.im * b.re;
}
void cadd(creal_T a,creal_T b,creal_T *c)
{
   c->re = a.re + b.re;
   c->im = a.im + b.im;
}
void csub(creal_T a,creal_T b,creal_T *c)
{
	c->re = a.re - b.re;
	c->im = a.im - b.im;
}

